/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.lib.basic.filters.SegmentationMask;

import javax.swing.DefaultComboBoxModel;
import org.visnow.jscic.RegularField;

/**
 *
 * @author babor
 */
public class GUI extends javax.swing.JPanel
{

    private Params params = new Params();
    private RegularField inField = null;
    private RegularField inSegmentationField = null;
    private DefaultComboBoxModel segmentationModel = new DefaultComboBoxModel();
    private boolean silent = false;

    /**
     * Creates new form GUI
     */
    public GUI()
    {
        initComponents();
    }

    private void updateGUI()
    {
        silent = true;
        if (inField == null) {
            fieldComponentSelector.setEnabled(false);
            fieldComponentSelector.setDataSchema(null);
        } else {
            fieldComponentSelector.setEnabled(true);
            fieldComponentSelector.setDataSchema(inField.getSchema());
            fieldComponentSelector.setComponent(params.getSelectedComponent());
        }

        if (inSegmentationField == null) {
            segmentationSelector.setEnabled(false);
            segmentationSelector.setModel(new DefaultComboBoxModel());
        } else {
            segmentationModel.removeAllElements();
            String[] uData = inSegmentationField.getComponent(0).getUserData();
            if (uData != null && uData.length > 1 && uData[0].equals("MAP")) {
                for (int i = 1; i < uData.length; i++) {
                    segmentationModel.addElement(uData[i]);
                }
                segmentationSelector.setEnabled(true);
                segmentationSelector.setModel(segmentationModel);
                segmentationSelector.setSelectedIndex(params.getSelectedSegmentation());
            } else {
                segmentationSelector.setEnabled(false);
                segmentationSelector.setModel(new DefaultComboBoxModel());
            }
        }
        silent = false;
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        fieldComponentSelector = new org.visnow.vn.lib.gui.DataComponentSelector();
        jPanel1 = new javax.swing.JPanel();
        segmentationSelector = new javax.swing.JComboBox();

        setMinimumSize(new java.awt.Dimension(200, 600));
        setPreferredSize(new java.awt.Dimension(200, 600));
        setLayout(new java.awt.GridBagLayout());

        fieldComponentSelector.setTitle("Field component");
        fieldComponentSelector.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                fieldComponentSelectorStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 0, 5);
        add(fieldComponentSelector, gridBagConstraints);

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("Segmentation"));
        jPanel1.setLayout(new java.awt.BorderLayout());

        segmentationSelector.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                segmentationSelectorActionPerformed(evt);
            }
        });
        jPanel1.add(segmentationSelector, java.awt.BorderLayout.CENTER);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        add(jPanel1, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    private void fieldComponentSelectorStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_fieldComponentSelectorStateChanged
        if (!silent)
            params.setSelectedComponent(fieldComponentSelector.getComponent());
    }//GEN-LAST:event_fieldComponentSelectorStateChanged

    private void segmentationSelectorActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_segmentationSelectorActionPerformed
        if (!silent)
            params.setSelectedSegmentation(segmentationSelector.getSelectedIndex());
    }//GEN-LAST:event_segmentationSelectorActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private org.visnow.vn.lib.gui.DataComponentSelector fieldComponentSelector;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JComboBox segmentationSelector;
    // End of variables declaration//GEN-END:variables
    /**
     * @param params the params to set
     */
    public void setParams(Params params)
    {
        this.params = params;
    }

    /**
     * @param inField the inField to set
     */
    public void setInField(RegularField inField)
    {
        this.inField = inField;
        updateGUI();
    }

    /**
     * @param inSegmentationField the inSegmentationField to set
     */
    public void setInSegmentationField(RegularField inSegmentationField)
    {
        this.inSegmentationField = inSegmentationField;
        updateGUI();
    }

}
